From 759d75b1977d74dac72557121db52f7ca8f1523f Mon Sep 17 00:00:00 2001
From: Nils Philippsen <nils@redhat.com>
Date: Dec 11 2017 13:50:06 +0000
Subject: [PATCH 17/51] add checks for the dependencies block


---

diff --git a/src/_fedmod/modulemd_linter.py b/src/_fedmod/modulemd_linter.py
index b8a996d..71ba0d2 100644
--- a/src/_fedmod/modulemd_linter.py
+++ b/src/_fedmod/modulemd_linter.py
@@ -107,6 +107,8 @@ class ModuleMDLinter(object):
     to do this is using the check()/check_true(), check_false() methods which
     all accept boolean expressions."""
 
+    yaml_scalar_types = (str, int, float)
+
     def __init__(self, modulemd_path=None, modulemd_str=None):
         if bool(modulemd_path) == bool(modulemd_str):
             raise ValueError(
@@ -307,3 +309,66 @@ class ModuleMDLinter(object):
         """The packager MAY also define a list of content licenses."""
         if 'content' in self.yaml_data['license']:
             self.check(isinstance(self.yaml_data['license']['content'], list))
+
+    @error
+    @guidelines_link('#Module_dependencies')
+    @detail("The dependencies block must be a dictionary (key/value).")
+    def lint_dependencies_dict(self):
+        """Modules MAY depend on other modules. These module relationships are
+        listed in the dependencies block. Dependencies are expressed using
+        module names and their stream names."""
+        if 'dependencies' in self.mmd:
+            self.check(isinstance(self.yaml_data['dependencies'], dict))
+
+    @error
+    @guidelines_link('#Module_dependencies')
+    @detail("The 'buildrequires' dependencies block must be a dictionary"
+            " (key/value).")
+    @prerequisite('dependencies_dict')
+    def lint_buildrequires(self):
+        """Modules MAY depend on other modules. These module relationships are
+        listed in the dependencies block. Dependencies are expressed using
+        module names and their stream names."""
+        self.check(isinstance(self.yaml_data['dependencies']['buildrequires'],
+                              dict))
+
+    @error
+    @guidelines_link('#Module_dependencies')
+    @detail("The 'buildrequires' dictionary must associate module name keys"
+            " with stream name values.")
+    @prerequisite('buildrequires')
+    def lint_buildrequires_items(self):
+        """Modules MAY depend on other modules. These module relationships are
+        listed in the dependencies block. Dependencies are expressed using
+        module names and their stream names."""
+        self.check(all(
+            isinstance(k, self.yaml_scalar_types)
+            and isinstance(v, self.yaml_scalar_types)
+            for k, v in
+            self.yaml_data['dependencies']['buildrequires'].items()))
+
+    @error
+    @guidelines_link('#Module_dependencies')
+    @detail("The 'requires' dependencies block must be a dictionary"
+            " (key/value).")
+    @prerequisite('dependencies')
+    def lint_requires(self):
+        """Modules MAY depend on other modules. These module relationships are
+        listed in the dependencies block. Dependencies are expressed using
+        module names and their stream names."""
+        self.check(isinstance(self.yaml_data['dependencies']['requires'],
+                              dict))
+
+    @error
+    @guidelines_link('#Module_dependencies')
+    @detail("The 'requires' dictionary must associate module name keys with"
+            " stream name values.")
+    @prerequisite('requires')
+    def lint_requires_items(self):
+        """Modules MAY depend on other modules. These module relationships are
+        listed in the dependencies block. Dependencies are expressed using
+        module names and their stream names."""
+        self.check(all(
+            isinstance(k, self.yaml_scalar_types)
+            and isinstance(v, self.yaml_scalar_types)
+            for k, v in self.yaml_data['dependencies']['requires'].items()))

